/* @(#) $Id: util.h 650 2010-02-04 03:02:03Z leres $ (LBL) */
#ifndef acld_util_h
#define acld_util_h

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#include <stdarg.h>

struct s2v {
	const char *s;
	int v;
};

struct v2v {
	int	v1;
	int	v2;
};

extern struct s2v syslog2str[];

#ifdef __STDC__
struct addr;
#endif
void addr2sa(struct addr *, u_short, struct sockaddr *);
const char *addr2str(struct addr *);
void checklf(void);
const char *checkmaskwidth(struct addr *, int, int);
void *dynarray(void *, size_t, size_t *, size_t, int, int, const char *);
const char *escapestr(const char *);
const char *extractaddr(const char *, const char *, struct addr *);
const char *extracthost(const char *, const char *, struct addr *);
const char *fmtargv(int, char **);
void freeargv(char **);
void *freedynarray(void *, size_t *, size_t *);
void getts(struct timeval *);
#ifndef HAVE_INET_ATON
#ifdef __STDC__
struct in_addr;
#endif
int inet_aton(const char *, struct in_addr *);
#endif
int insubnet(const struct addr *, const struct addr *);
int isdefaultaddr(struct addr *);
void lg(int, const char *, ...)
    __attribute__ ((format (printf, 2, 3)));
int makeargv(const char *, char ***);
int maskwidth(struct addr *);
void *new(size_t, size_t, const char *);
const char *pretty(const char *, ssize_t);
void sa2addr(struct sockaddr *, struct addr *, u_int16_t *);
void setmaskwidth(u_int, struct addr *);
const char *simplewd(void);
int str2val(const struct s2v *, const char *);
int str2valcase(const struct s2v *, const char *);
void strappend(char **, const char *);
char *strsave(const char *);
int suck2dot(FILE *, char **);
void trimws(char *, size_t);
const char * tsstr(void);
int typ2flag(const struct v2v *, int);
const char *val2str(const struct s2v *, int);

#define FREEDYNARRAY(p, lenp, sizep) \
    p = freedynarray(p, lenp, sizep)
#define DYNARRAY(p, len, sizep, osize, isize, inc, what) \
    p = dynarray(p, len, sizep, osize, isize, inc, what)
#endif
